// Code generated by gowrap. DO NOT EDIT.
// template: ../../../assets/templates/middleware/access_log.tmpl
// gowrap: http://github.com/hexdigest/gowrap

package middleware

//go:generate gowrap gen -p git.perx.ru/perxis/perxis-go/pkg/organizations -i Organizations -t ../../../assets/templates/middleware/access_log.tmpl -o access_logging_middleware.go -l ""

import (
	"context"
	"time"

	"git.perx.ru/perxis/perxis-go/pkg/auth"
	"git.perx.ru/perxis/perxis-go/pkg/options"
	"git.perx.ru/perxis/perxis-go/pkg/organizations"
	"go.uber.org/zap"
)

// accessLoggingMiddleware implements organizations.Organizations that is instrumented with logging
type accessLoggingMiddleware struct {
	logger *zap.Logger
	next   organizations.Organizations
}

// AccessLoggingMiddleware instruments an implementation of the organizations.Organizations with simple logging
func AccessLoggingMiddleware(logger *zap.Logger) Middleware {
	return func(next organizations.Organizations) organizations.Organizations {
		return &accessLoggingMiddleware{
			next:   next,
			logger: logger,
		}
	}
}

func (m *accessLoggingMiddleware) Create(ctx context.Context, org *organizations.Organization) (created *organizations.Organization, err error) {
	begin := time.Now()

	m.logger.Debug("Create.Request",
		zap.Reflect("principal", auth.GetPrincipal(ctx)),
		zap.Reflect("org", org),
	)

	created, err = m.next.Create(ctx, org)

	m.logger.Debug("Create.Response",
		zap.Duration("time", time.Since(begin)),
		zap.Reflect("created", created),
		zap.Error(err),
	)

	return created, err
}

func (m *accessLoggingMiddleware) Delete(ctx context.Context, orgId string) (err error) {
	begin := time.Now()

	m.logger.Debug("Delete.Request",
		zap.Reflect("principal", auth.GetPrincipal(ctx)),
		zap.Reflect("orgId", orgId),
	)

	err = m.next.Delete(ctx, orgId)

	m.logger.Debug("Delete.Response",
		zap.Duration("time", time.Since(begin)),
		zap.Error(err),
	)

	return err
}

func (m *accessLoggingMiddleware) Find(ctx context.Context, filter *organizations.Filter, opts *options.FindOptions) (orgs []*organizations.Organization, total int, err error) {
	begin := time.Now()

	m.logger.Debug("Find.Request",
		zap.Reflect("principal", auth.GetPrincipal(ctx)),
		zap.Reflect("filter", filter),
		zap.Reflect("opts", opts),
	)

	orgs, total, err = m.next.Find(ctx, filter, opts)

	m.logger.Debug("Find.Response",
		zap.Duration("time", time.Since(begin)),
		zap.Reflect("orgs", orgs),
		zap.Reflect("total", total),
		zap.Error(err),
	)

	return orgs, total, err
}

func (m *accessLoggingMiddleware) Get(ctx context.Context, orgId string) (org *organizations.Organization, err error) {
	begin := time.Now()

	m.logger.Debug("Get.Request",
		zap.Reflect("principal", auth.GetPrincipal(ctx)),
		zap.Reflect("orgId", orgId),
	)

	org, err = m.next.Get(ctx, orgId)

	m.logger.Debug("Get.Response",
		zap.Duration("time", time.Since(begin)),
		zap.Reflect("org", org),
		zap.Error(err),
	)

	return org, err
}

func (m *accessLoggingMiddleware) Update(ctx context.Context, org *organizations.Organization) (err error) {
	begin := time.Now()

	m.logger.Debug("Update.Request",
		zap.Reflect("principal", auth.GetPrincipal(ctx)),
		zap.Reflect("org", org),
	)

	err = m.next.Update(ctx, org)

	m.logger.Debug("Update.Response",
		zap.Duration("time", time.Since(begin)),
		zap.Error(err),
	)

	return err
}
